unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DirectShow9, StdCtrls;

type
  TForm1 = class(TForm)
    StartButton: TButton;
    StopButton: TButton;
    procedure StartButtonClick(Sender: TObject);
    procedure StopButtonClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    FGraph              : IGraphBuilder;
    FMediaControl       : IMediaControl;

  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses ActiveX;

procedure TForm1.StartButtonClick(Sender: TObject);
var
  WideFileName  : WideString;

begin
  CoCreateInstance( CLSID_FilterGraph, NIL, CLSCTX_INPROC, IGraphBuilder, FGraph );
  WideFileName := 'Demo.avi';
  FGraph.RenderFile( @( WideFileName[ 1 ] ), NIL );
  
  FGraph.QueryInterface( IMediaControl, FMediaControl );
  FMediaControl.Run();

  StartButton.Enabled := False;
  StopButton.Enabled := True;
end;

procedure TForm1.StopButtonClick(Sender: TObject);
begin
  if( FMediaControl = NIL ) then
    Exit;
    
  FMediaControl.Stop();
  
  StartButton.Enabled := True;
  StopButton.Enabled := False;

  FMediaControl := NIL;
  FGraph := NIL;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  StopButtonClick( Sender );
end;

end.
