unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls;

type
  TForm1 = class(TForm)
    Image1: TImage;
    Image2: TImage;
    Button1: TButton;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

const
  MATRIX_SIZE = 5;
  HALF_MATRIX = MATRIX_SIZE div 2; 

procedure TForm1.Button1Click(Sender: TObject);
var
  X, Y : Integer;
  XM, YM : Integer;
  ASum : Integer;
  AInBitmap : TBitmap;
  AOutBitmap : TBitmap;

begin
  AInBitmap := Image1.Picture.Bitmap;
  
  AOutBitmap := TBitmap.Create();
  AOutBitmap.Width := AInBitmap.Width - MATRIX_SIZE + 1;
  AOutBitmap.Height := AInBitmap.Height - MATRIX_SIZE + 1;

  for Y := HALF_MATRIX to AInBitmap.Height - HALF_MATRIX - 1 do
    for X := HALF_MATRIX to AInBitmap.Width - HALF_MATRIX - 1 do
      begin
      ASum := 0;
      for YM := Y - HALF_MATRIX to Y + HALF_MATRIX do
        for XM := X - HALF_MATRIX to X + HALF_MATRIX do
          Inc( ASum, GetRValue( AInBitmap.Canvas.Pixels[ XM, YM ] ));

      ASum := ASum div ( MATRIX_SIZE * MATRIX_SIZE );
      AOutBitmap.Canvas.Pixels[ X - HALF_MATRIX, Y - HALF_MATRIX ] := RGB( ASum, ASum, ASum );
      end;

  Image2.Picture.Bitmap.Assign( AOutBitmap );
  AOutBitmap.Free();
end;

type
  TPixels = array [0..10000] of Integer;
  PPixels = ^TPixels;

procedure TForm1.Button2Click(Sender: TObject);
var
  X, Y       : Integer;
  XM, YM     : Integer;
  ASum       : Integer;
  AInBitmap  : TBitmap;
  AOutBitmap : TBitmap;
  AInPtr     : PPixels;
  AOutPtr    : PInteger;
  AInStep    : Integer;

begin
  AInBitmap := Image1.Picture.Bitmap;
  AInBitmap.PixelFormat := pf32bit;
  AInStep := AInBitmap.Width;

  AOutBitmap := TBitmap.Create();
  AOutBitmap.PixelFormat := pf32bit;
  AOutBitmap.Width := AInBitmap.Width - MATRIX_SIZE + 1;
  AOutBitmap.Height := AInBitmap.Height - MATRIX_SIZE + 1;

  AInPtr := AInBitmap.ScanLine[ AInBitmap.Height - 1 ];
  AOutPtr := AOutBitmap.ScanLine[ AOutBitmap.Height - 1 ];

  for Y := HALF_MATRIX to AInBitmap.Height - HALF_MATRIX - 1 do
    for X := HALF_MATRIX to AInBitmap.Width - HALF_MATRIX - 1 do
      begin
      ASum := 0;
      for YM := Y - HALF_MATRIX to Y + HALF_MATRIX do
        for XM := X - HALF_MATRIX to X + HALF_MATRIX do
          Inc( ASum, GetRValue( AInPtr[ XM + YM * AInStep ] ));  

      ASum := ASum div ( MATRIX_SIZE * MATRIX_SIZE );
      AOutPtr^ := RGB( ASum, ASum, ASum );
      Inc( AOutPtr );
      end;

  Image2.Picture.Bitmap.Assign( AOutBitmap );
  AOutBitmap.Free();
end;

end.
